unit UMainForm;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, UPascalParser;

type
  { TMainForm }
  TMainForm = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Memo2: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    Tokenizer: TPascalTokenizer;
  end; 

var
  MainForm: TMainForm;

implementation

{ TMainForm }

procedure TMainForm.FormShow(Sender: TObject);
begin
  Memo1.Lines.LoadFromFile('Source.pas');
end;

procedure TMainForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Memo1.Lines.SaveToFile('Source.pas');
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Tokenizer := TPascalTokenizer.Create;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Tokenizer.Destroy;
end;

procedure TMainForm.Button1Click(Sender: TObject);
var
  I: Integer;
  Token: string;
begin
  Memo2.Clear;
  Tokenizer.Tokenize(Memo1.Lines.Text);
  for I := 0 to Tokenizer.Tokens.Items.Count - 1 do
    Memo2.Lines.Add(Tokenizer.Tokens.Items[I]);
end;

initialization
  {$I UMainForm.lrs}

end.

